!********************************************************************************
!*	lattice heat capacity from Phonon DOS					*
!*										*
!********************************************************************************

	program lattice_heat
	
	implicit none
	integer s,anz,t,anzt
	parameter (anz=339)
	real*8 warray(1:anz),dosarray(1:anz),dt,t0,t1,tl,dbosedt,beta,fac
	real*8 sum,dw,volume,td,cvd,pi
	parameter (pi=3.141592654)
	parameter (t0=10.,t1=1000.,dt=10.)
	character*10 cdummy

!-------wikipedia
	td=343.d0
!-------DFT
!	td=690.0
	
!	volume=0.5*(5.20808*0.529177)**3.d0
	volume=1.4948982E+02*0.14818
	anzt=int((t1-t0)/dt)+min(modulo((t1-t0),dt),1.0)
	write(*,*) volume,anzt
!-------
	open(42,file='./elphon/co_elphon_4.out_ep_PDS',status='old')
	
	do s=1,11
	 read(42,*) cdummy
	end do
	
	do s=1,anz
	 read(42,*) warray(s),dosarray(s)
	end do
	
	close(42)
	
!-------warray is in Ha, dosarray is in states/Ha/cell (with an odd factor of three)

	do t=1,anzt
	 tl=t0+dt*(t-1)
	 beta=1.0/0.633376e-5/tl*2.d0
	 sum=0.0
	 do s=3,anz
	  dw=warray(s)-warray(s-1)
	  fac=exp(beta*warray(s-1))
	  dbosedt=beta/tl*warray(s-1)*fac/((fac-1.0)**2.0)
	  sum=sum+0.5*dbosedt*dosarray(s-1)*warray(s-1)*dw
!	  write(*,*) warray(s-1),fac
!	  write(*,*) s-1,warray(s-1),sum,dosarray(s-1),dbosedt
!	  read(*,*)
	  fac=exp(beta*warray(s))
	  dbosedt=beta/tl*warray(s)*fac/((fac-1.0)**2.0)
	  sum=sum+0.5*dbosedt*dosarray(s)*warray(s)*dw
!	  write(*,*) s,warray(s),sum,dosarray(s-1),dbosedt
	 end do
	 call debye(tl,td,cvd)
!--------Ha/K, with normalization a la abinit, then into eV/k and J/mol/K
!	 write(*,'(F7.2,Es15.7,A5,F8.5,A8,Es15.7,A5,Es15.7)') tl,sum/volume*3*2*13.6,"eV/K",sum/volume*3*2*13.6*1.602e-19*6.022e23,"J/mol/K",cvd*13.6,"eV/K",12./5.*pi*pi*pi*pi*0.633376e-5*13.6*tl*tl*tl/td/td/td
	 write(*,'(F7.2,Es15.7,A5,F9.5,A8,Es15.7,A5,Es15.7)') tl,sum*2*13.6,"eV/K",sum*2*13.6*1.602e-19*6.022e23,"J/mol/K",cvd*13.6,"eV/K",12./5.*pi*pi*pi*pi*0.633376e-5*13.6*tl*tl*tl/td/td/td
	end do 

!-------end of main--------------------------------------------------------------	
	end


!********************************************************************************
!*	subroutines								*
!********************************************************************************

	subroutine debye(T,TD,cvd)
	
	implicit none
	
!	integer
	real*8 rgauss,eps,a,b,cvd,t,td,integr
	external rgauss,integr

	 a=0.d0
	 b=TD/T
	 eps=1.d-5
	 cvd=rgauss(integr,a,b,eps)
	 cvd=cvd*9*0.633376e-5*(T/TD)*(T/TD)*(T/TD)
	 
	return
	end
	
!------------------------------------------
	
	real*8 function integr(x)
	
	implicit none
	real*8 x
	
	 integr=x*x*x*x*exp(x)/(exp(x)-1.)/(exp(x)-1.)
	
	return
	end
	
!------------------------------------------------------------------------------

      real*8 function rgauss(f, a, b, eps)
!
!     **********************************************************
!
!     ADAPTIVE REAL GAUSSIAN QUADRATURE
!
!     dgauss is set equal to the approximate value of the
!     integral of the function f over the interval (a,b),
!     with accuracy parameter eps
!     AUTHOR: K.S. Koelbig (CERN)
!     **********************************************************
!
      real*8 f, a, b, eps
      real*8 w(12), x(12), aa, bb, c1, c2, u, s8, s16,  const
      external         f

      data w / 0.1012285362903762591525313543E00,0.2223810344533744705443559944E00,0.3137066458778872873379622020E00,0.3626837833783619829651504493E00,0.2715245941175409485178057246E-1,0.6225352393864789286284383699E-1,0.9515851168249278480992510760E-1,0.1246289712555338720524762822E00,0.1495959888165767320815017305E00,0.1691565193950025381893120790E00,0.1826034150449235888667636680E00,0.1894506104550684962853967232E00/

      data x / 0.9602898564975362316835608686E00,0.7966664774136267395915539365E00,0.5255324099163289858177390492E00,0.1834346424956498049394761424E00,0.9894009349916499325961541753E00,0.9445750230732325760779884155E00,0.8656312023878317438804678977E00,0.7554044083550030338951011948E00,0.6178762444026437484466717640E00,0.4580167776572273863424194430E00,0.2816035507792589132304605015E00,0.9501250983763744018531933543E-1/


!  START
      rgauss = 0.0E0
      if (b .eq. a) return
      const  = 1.d-10/(b-a)
      bb     = a

!  COMPUTATIONAL LOOP
1     aa = bb
      bb = b
2          c1 = 0.5E0*(bb+aa)
           c2 = 0.5E0*(bb-aa)
           s8 = 0.0E0
           do 3, i=1,4
             u  = c2*x(i)
             s8 = s8 + w(i)*(f(c1+u)+f(c1-u))
3          continue
           s8  = c2*s8
           s16 = 0.0E0
           do 4 i=5,12
             u   = c2*x(i)
             s16 = s16 + w(i)*(f(c1+u)+f(c1-u))
4          continue
           s16 = c2*s16
! Originalcheck
!           if ( abs(s16-s8) .le. eps*(1.E0+abs(s16)) ) go to 5
! Mein Check auf Genauigkeit:
             if ( abs(s16-s8) .le. eps/2.E0*abs(s16+s8)) go to 5
           bb = c1
!           if ( 1.0E0+abs(const*c2) .ne. 1.0E0) go to 2
             if (2.E0*c2 .ge. eps*32.E0*const) go to 2
!      rgauss = 0.E0
!      write(*,6)
!      return
5     rgauss = rgauss + s16
      if (bb .ne. b) go to 1
      return
6     format(4X, 'FUNCTION RGAUSS ... TOO HIGH ACCURACY REQUIRED')
      end
